## pwncat 0.1.2

=== Makefile ===
ifneq (,)
.error This Makefile requires GNU Make.
endif

# -------------------------------------------------------------------------------------------------
# Can be changed
# -------------------------------------------------------------------------------------------------
# This can be adjusted
PYTHON_VERSION = 2.7


# -------------------------------------------------------------------------------------------------
# Default configuration
# -------------------------------------------------------------------------------------------------
.PHONY: help lint code test smoke autoformat docs pipeline build deploy clean

BINPATH = bin/
MANPATH = man/
DOCPATH = docs/
INTPATH = tests/integration/
BINNAME = pwncat

FL_VERSION = 0.4
FL_IGNORES = .git/,.github/,$(BINNAME).egg-info,docs/$(BINNAME).api.html,docs/,data/,.mypy_cache/,share/doc/venv,share/doc/_build,share/pkg/nixos,share/pkg/blackarch/

UID := $(shell id -u)
GID := $(shell id -g)


# -------------------------------------------------------------------------------------------------
# Default Target
# -------------------------------------------------------------------------------------------------
help:
	@echo " ██▓███   █     █░ ███▄    █  ▄████▄   ▄▄▄      ▄▄▄█████▓"
	@echo "▓██░  ██▒▓█░ █ ░█░ ██ ▀█   █ ▒██▀ ▀█  ▒████▄    ▓  ██▒ ▓▒"
	@echo "▓██░ ██▓▒▒█░ █ ░█ ▓██  ▀█ ██▒▒▓█    ▄ ▒██  ▀█▄  ▒ ▓██░ ▒░"
	@echo "▒██▄█▓▒ ▒░█░ █ ░█ ▓██▒  ▐▌██▒▒▓▓▄ ▄██▒░██▄▄▄▄██ ░ ▓██▓ ░ "
	@echo "▒██▒ ░  ░░░██▒██▓ ▒██░   ▓██░▒ ▓███▀ ░ ▓█   ▓██▒  ▒██▒ ░ "
	@echo "▒▓▒░ ░  ░░ ▓░▒ ▒  ░ ▒░   ▒ ▒ ░ ░▒ ▒  ░ ▒▒   ▓▒█░  ▒ ░░   "
	@echo "░▒ ░       ▒ ░ ░  ░ ░░   ░ ▒░  ░  ▒     ▒   ▒▒ ░    ░    "
	@echo "░░         ░   ░     ░   ░ ░ ░          ░   ▒     ░      "
	@echo "             ░             ░ ░ ░            ░  ░         "
	@echo "                             ░                           "
	@echo
	@echo "lint             Lint repository"
	@echo "code             Lint source code"
	@echo "test             Run integration tests"
	@echo "smoke            Run smokke tests (dockerized)"
	@echo "autoformat       Autoformat code according to Python black"
	@echo
	@echo "docs             Update code documentation"
	@echo "pipeline         Update GitHub action workflow pipelines"
	@echo
	@echo "build            Build Python pkg, source and binary dist"
	@echo "deploy           Deploy pip package"
	@echo "clean            Clean the Build"


# -------------------------------------------------------------------------------------------------
# Lint Targets
# -------------------------------------------------------------------------------------------------
lint: _lint-files
lint: _lint-version
lint: _lint-usage
lint: _lint-docs
lint: _lint-man
lint: _lint-pipeline

.PHONY: _lint-version
_lint-version:
	@echo "# -------------------------------------------------------------------- #"
	@echo "# Check version config"
	@echo "# -------------------------------------------------------------------- #"
	@VERSION_PWNCAT=$$( grep -E '^VERSION = "[.0-9]+(-\w+)?"' bin/pwncat | awk -F'"' '{print $$2}' || true ); \
	VERSION_SETUP=$$( grep version= setup.py | awk -F'"' '{print $$2}' || true ); \
	VERSION_CHANGE=$$( grep -E '## Release [.0-9]+(-\w+)?$$' CHANGELOG.md | head -1 | sed 's/.*[[:space:]]//g' || true ); \
	if [ "$${VERSION_PWNCAT}" != "$${VERSION_SETUP}" ] || [ "$${VERSION_SETUP}" != "$${VERSION_CHANGE}" ]; then \
		echo "[ERROR] Version mismatch"; \
		echo "bin/pwncat:   $${VERSION_PWNCAT}"; \
		echo "setup.py:     $${VERSION_SETUP}"; \
		echo "CHANGELOG.md: $${VERSION_CHANGE}    # Looking for latest entry with regex format: '## Release [.0-9]+(\w+)?$$'" ; \
		exit 1; \
	else \
		echo "[OK] Version match"; \
		echo "bin/pwncat:   $${VERSION_PWNCAT}"; \
		echo "setup.py:     $${VERSION_SETUP}"; \
		echo "CHANGELOG.md: $${VERSION_CHANGE}"; \
		exit 0; \
	fi \

.PHONY: _lint-usage
_lint-usage: SHELL := /bin/bash
_lint-usage:
	@echo "# -------------------------------------------------------------------- #"
	@echo "# Lint usage"
	@echo "# -------------------------------------------------------------------- #"
	$(PWD)/tests/bin/check-usage.sh

.PHONY: _lint-files
_lint-files:
	@echo "# --------------------------------------------------------------------"
	@echo "# Lint files"
	@echo "# -------------------------------------------------------------------- #"
	@docker run --rm $$(tty -s && echo "-it" || echo) -v $(PWD):/data cytopia/file-lint:$(FL_VERSION) file-cr --text --ignore '$(FL_IGNORES)' --path .
	@docker run --rm $$(tty -s && echo "-it" || echo) -v $(PWD):/data cytopia/file-lint:$(FL_VERSION) file-crlf --text --ignore '$(FL_IGNORES)' --path .
	@docker run --rm $$(tty -s && echo "-it" || echo) -v $(PWD):/data cytopia/file-lint:$(FL_VERSION) file-trailing-single-newline --text --ignore '$(FL_IGNORES)' --path .
	@docker run --rm $$(tty -s && echo "-it" || echo) -v $(PWD):/data cytopia/file-lint:$(FL_VERSION) file-trailing-space --text --ignore '$(FL_IGNORES)' --path .
	@docker run --rm $$(tty -s && echo "-it" || echo) -v $(PWD):/data cytopia/file-lint:$(FL_VERSION) file-utf8 --text --ignore '$(FL_IGNORES)' --path .
	@docker run --rm $$(tty -s && echo "-it" || echo) -v $(PWD):/data cytopia/file-lint:$(FL_VERSION) file-utf8-bom --text --ignore '$(FL_IGNORES)' --path .
	@docker run --rm $$(tty -s && echo "-it" || echo) -v $(PWD):/data cytopia/file-lint:$(FL_VERSION) git-conflicts --text --ignore '$(FL_IGNORES)' --path .

.PHONY: _lint-docs
_lint-docs:
	@echo "# -------------------------------------------------------------------- #"
	@echo "# Lint docs"
	@echo "# -------------------------------------------------------------------- #"
	@$(MAKE) --no-print-directory docs
	git diff --quiet -- $(DOCPATH) || { echo "Build Changes"; git diff | cat; git status; false; }
	git diff --quiet -- $(PWD)/README.md || { echo "Build Changes"; git diff | cat; git status; false; }

.PHONY: _lint-man
_lint-man:
	@echo "# -------------------------------------------------------------------- #"
	@echo "# Lint man page"
	@echo "# -------------------------------------------------------------------- #"
	@$(MAKE) --no-print-directory man
	git diff --quiet -- $(DOCPATH) $(MANPATH) || { echo "Build Changes"; git diff | cat; git status; false; }

.PHONY: _lint-pipeline
_lint-pipeline:
	@echo "# -------------------------------------------------------------------- #"
	@echo "# Lint Pipelines"
	@echo "# -------------------------------------------------------------------- #"
	@$(MAKE) --no-print-directory pipeline
	git diff --quiet -- .github/workflows || { echo "Build Changes"; git diff | cat; git status; false; }


# -------------------------------------------------------------------------------------------------
# Code Style Targets
# -------------------------------------------------------------------------------------------------
code: _code-pycodestyle
code: _code-pydocstyle
code: _code-pylint
code: _code-black
code: _code-mypy

.PHONY: _code-pycodestyle
_code-pycodestyle:
	@V="$$( docker run --rm cytopia/pycodestyle --version | head -1 )"; \
	echo "# -------------------------------------------------------------------- #"; \
	echo "# Check pycodestyle: $${V}"; \
	echo "# -------------------------------------------------------------------- #"
	@#
	docker pull cytopia/pycodestyle
	docker run --rm $$(tty -s && echo "-it" || echo) -v $(PWD):/data --entrypoint= cytopia/pycodestyle sh -c ' \
		mkdir -p /tmp \
		&& cp $(BINPATH)$(BINNAME) /tmp/$(BINNAME).py \
		&& pycodestyle --config=setup.cfg /tmp/$(BINNAME).py'

.PHONY: _code-pydocstyle
_code-pydocstyle:
	@V="$$( docker run --rm cytopia/pydocstyle --version | head -1 )"; \
	echo "# -------------------------------------------------------------------- #"; \
	echo "# Check pydocstyle: $${V}"; \
	echo "# -------------------------------------------------------------------- #"
	@#
	docker pull cytopia/pydocstyle
	docker run --rm $$(tty -s && echo "-it" || echo) -v $(PWD):/data --entrypoint= cytopia/pydocstyle sh -c ' \
		mkdir -p /tmp \
		&& cp $(BINPATH)$(BINNAME) /tmp/$(BINNAME).py \
		&& pydocstyle --explain --config=setup.cfg /tmp/$(BINNAME).py'

.PHONY: _code-pylint
_code-pylint:
	@V="$$( docker run --rm cytopia/pylint --version | head -1 )"; \
	echo "# -------------------------------------------------------------------- #"; \
	echo "# Check pylint: $${V}"; \
	echo "# -------------------------------------------------------------------- #"
	@#
	docker pull cytopia/pylint
	docker run --rm $$(tty -s && echo "-it" || echo) -v $(PWD):/data --entrypoint= cytopia/pylint sh -c ' \
		mkdir -p /tmp \
		&& cp $(BINPATH)$(BINNAME) /tmp/$(BINNAME).py \
		&& pylint --rcfile=setup.cfg /tmp/$(BINNAME).py'

.PHONY: _code-black
_code-black:
	@V="$$( docker run --rm cytopia/black --version | head -1 )"; \
	echo "# -------------------------------------------------------------------- #"; \
	echo "# Check Python Black: $${V}"; \
	echo "# -------------------------------------------------------------------- #"
	@#
	docker pull cytopia/black
	docker run --rm $$(tty -s && echo "-it" || echo) -v ${PWD}:/data --entrypoint= cytopia/black sh -c ' \
		mkdir -p /tmp \
		&& cp $(BINPATH)$(BINNAME) /tmp/$(BINNAME).py \
		&& black -l 100 --check --diff /tmp/$(BINNAME).py'

.PHONY: _code-mypy
_code-mypy:
	@V="$$( docker run --rm cytopia/mypy --version | head -1 )"; \
	echo "# -------------------------------------------------------------------- #"; \
	echo "# Check Mypy: $${V}"; \
	echo "# -------------------------------------------------------------------- #"
	@#
	docker pull cytopia/mypy
	docker run --rm $$(tty -s && echo "-it" || echo) -v ${PWD}:/data --entrypoint= cytopia/mypy sh -c ' \
		mkdir -p /tmp \
		&& cp $(BINPATH)$(BINNAME) /tmp/$(BINNAME).py \
		&& mypy --config-file setup.cfg /tmp/$(BINNAME).py'


# -------------------------------------------------------------------------------------------------
# Smoke Targets
# -------------------------------------------------------------------------------------------------
smoke: _smoke-keep_open-kill_srv-before_send
smoke: _smoke-keep_open-kill_srv-send_data
smoke: _smoke-tcp_port_scan-no_banner
smoke: _smoke-tcp_port_scan-with_banner
smoke: _smoke-udp_port_scan-no_banner
smoke: _smoke-udp_port_scan-with_banner

.PHONY:
_smoke-keep_open-kill_srv-before_send:
	@# It's sometimes a race-condition, so we run it five times
	tests/smoke/run.sh "200---tcp---keep_open---kill_server---no_send" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "200---tcp---keep_open---kill_server---no_send" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "200---tcp---keep_open---kill_server---no_send" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "200---tcp---keep_open---kill_server---no_send" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "200---tcp---keep_open---kill_server---no_send" "$(PYTHON_VERSION)"

_smoke-keep_open-kill_srv-send_data:
	@# It's sometimes a race-condition, so we run it five times
	tests/smoke/run.sh "201---tcp---keep_open---kill_server---send_data" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "201---tcp---keep_open---kill_server---send_data" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "201---tcp---keep_open---kill_server---send_data" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "201---tcp---keep_open---kill_server---send_data" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "201---tcp---keep_open---kill_server---send_data" "$(PYTHON_VERSION)"

_smoke-tcp_port_scan-no_banner:
	@# It's sometimes a race-condition, so we run it five times
	tests/smoke/run.sh "300---tcp---port_scan---no_banner" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "300---tcp---port_scan---no_banner" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "300---tcp---port_scan---no_banner" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "300---tcp---port_scan---no_banner" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "300---tcp---port_scan---no_banner" "$(PYTHON_VERSION)"

_smoke-tcp_port_scan-with_banner:
	@# It's sometimes a race-condition, so we run it five times
	tests/smoke/run.sh "301---tcp---port_scan---with_banner" "$(PYTHON_VERSION)"
