=== share/doc/requirements.txt ===
recommonmark
sphinx_rtd_theme
Pygments
