=== debian/changelog ===
pwncat (0.1.2-0kali3) kali-dev; urgency=medium

  * Add a patch to fix output for autopkgtest in Python3.13
  * Refresh patches
  * Bump Standards-Version to 4.7.0

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 10 Feb 2025 17:08:40 +0100

pwncat (0.1.2-0kali2) kali-dev; urgency=medium

  * Add lintian override
  * Add patch for setuptools >= 61 compatibility.
  * Update standards version to 4.6.2, no changes needed.
  * Prepare for Release

 -- Steev Klimaszewski <steev@kali.org>  Thu, 27 Apr 2023 21:09:24 -0500

pwncat (0.1.2-0kali1) kali-dev; urgency=medium

  [ Ben Wilson ]
  * Remove template comment and switch spaces to tabs

  [ Sophie Brun ]
  * New upstream version 0.1.2
  * Refresh patches
  * Bump Standards-Version to 4.6.0

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 11 Apr 2022 11:55:32 +0200

pwncat (0.1.1-0kali1) kali-dev; urgency=medium

  [ Kali Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Sophie Brun ]
  * New upstream version 0.1.1
  * Refresh patches
  * Add GitLab's CI configuration file
  * Configure git-buildpackage for Kali
  * Bump Standards-Version to 4.5.1 (no change)
  * Use debhelper-compat 13
  * Remove failing test
  * Add another superficial autopkgtest

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 11 Jun 2021 15:53:58 +0200

pwncat (0.1.0-0kali1) kali-dev; urgency=medium

  * Initial release (see 6457)

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 28 Jul 2020 11:04:58 +0200
