=== debian/control ===
Source: pwncat
Section: utils
Priority: optional
Maintainer: Kali Developers <devel@kali.org>
Uploaders: Sophie Brun <sophie@offensive-security.com>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               python3-all,
               python3-setuptools
Standards-Version: 4.7.0
Homepage: https://github.com/cytopia/pwncat
Vcs-Browser: https://gitlab.com/kalilinux/packages/pwncat
Vcs-Git: https://gitlab.com/kalilinux/packages/pwncat.git

Package: pwncat
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}
Description: netcat on steroids
 This package contains Netcat on steroids with Firewall, IDS/IPS evasion, bind
 and reverse shell, self-injecting shell and port forwarding magic - and its
 fully scriptable with Python (PSE).
