=== debian/tests/control ===
Test-Command: tests/bin/check-usage.sh && pwncat -h
Restrictions: allow-stderr, superficial
