=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%pwncat-$1.tar.gz%" \
   https://github.com/cytopia/pwncat/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
